####################
# Zope Army Knife  #
# (c) 2003 NAUMEN  #
####################
"""
Revision information:
$Id: ZAKTag.py,v 1.4 2003/05/17 14:09:09 vpastukhov Exp $

DTML ZAK tag class
"""
__version__ = '$Revision: 1.4 $'[11:-2]

from cgi import escape
from sys import exc_info
from traceback import format_exception_only, format_tb

from DocumentTemplate.DT_Util import render_blocks

import ZAKContext


class ZAKTag:
    name = 'zak'
    blockContinuations = []

    def __init__( self, blocks ):
        tname, args, section = blocks[0]
        self.blocks = section.blocks

    def __call__( self, md ):
        REQUEST = md['REQUEST']
        context = md['this']
        lines   = []

        expr = render_blocks( self.blocks, md )
        expr = expr.replace( '\r\n', '\n' ) + '\n'

        locals = { '_'       : md,
                   'REQUEST' : REQUEST,
                   'context' : context,
                   'app'     : context.getPhysicalRoot(), }

        try:
            eval( compile( expr, 'DTML-ZAK', 'exec' ), ZAKContext.__dict__, locals )

        except:
            type, value, tb = exc_info()

            lines += [ escape(s) for s in format_exception_only( type, value ) ] + ['']
            lines += [ escape(s) for s in format_tb( tb )[1:] ] + ['']

        vars = locals.keys()
        vars.sort()

        for k in [ '_', 'REQUEST', 'request' ]:
            try: vars.remove( k )
            except ValueError: pass

        lines += [ '<b>' + str(k) + '</b>&nbsp;=&nbsp;' + \
                   escape( str( locals[k] ) ) for k in vars ]

        result = '<code>\n' + '<br/>\n'.join( lines ) + '<br/>\n</code>\n'

        if locals.has_key( 'request' ):
            result += '<br/>\n<code><b>REQUEST</b>&nbsp;=</code><br/>\n'
            result += str( locals['REQUEST'] )
            result += '<br/>\n'

        return result

    render = __call__
